import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import {
  MesModelListItem,
  MesModelPageParams,
  MesModelPageListGetResultModel,
} from '../model/mesModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useUserStore } from '../../../store/modules/user';

/*
 * 获取产线分页列表
 */
export const getMesModelListByPage = async (params: MesModelPageParams) => {
  let sqlcmd = '';
  if (params?.MAT_MODEL != undefined && params?.MAT_MODEL != '') {
    sqlcmd += "And MAT_MODEL like '%" + params?.MAT_MODEL + "%'";
  }
  if (params?.MODEL_NAME != undefined && params?.MODEL_NAME != '') {
    sqlcmd += "And MODEL_NAME like '%" + params?.MODEL_NAME + "%'";
  }
  const rParams = genActionPage('MES_RULE', sqlcmd, params.page, params.pageSize);
  return getMesModelListByPageAsync(rParams);
};
async function getMesModelListByPageAsync(params: ApiActionPage) {
  //   const data = await defHttp.post<ApiActionPage>(
  //     { url: Api.EntityPageList, params },
  //     {
  //       isTransformResponse: false,
  //     },
  //   );
  const data: MesModelListItem[] = [
    {
      ID: '1',
      MAT_MODEL: 'MDS-133F02',
      MODEL_NAME: 'MDS-133F02',
      MODEL_DESC: 'MDS-133F02',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M133LD-F00',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '2',
      MAT_MODEL: 'MDS-15603',
      MODEL_NAME: 'MDS-15603',
      MODEL_DESC: 'MDS-15603',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '3',
      MAT_MODEL: 'MDS-15605',
      MODEL_NAME: 'MDS-15605',
      MODEL_DESC: 'MDS-15605',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '4',
      MAT_MODEL: 'MDS-156F13',
      MODEL_NAME: 'MDS-156F13',
      MODEL_DESC: 'MDS-156F13',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '5',
      MAT_MODEL: 'MDS-15603',
      MODEL_NAME: 'MDS-15603',
      MODEL_DESC: 'MDS-15603',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '6',
      MAT_MODEL: 'MDS-156F14',
      MODEL_NAME: 'MDS-156F14',
      MODEL_DESC: 'MDS-156F14',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
    {
      ID: '7',
      MAT_MODEL: 'ME16EA',
      MODEL_NAME: 'ME16EA',
      MODEL_DESC: 'ME16EA',
      FACTORY_CODE: '002',
      MAT_LINE: 'D04',
      IS_INV: 'Y',
      MAT_FAMILY: 'M156LD-XU',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
    },
  ];
  const model: MesModelPageListGetResultModel = {
    // items: data.Data.data,
    // total: data.Data.totals,
    items: data,
    total: data.length,
  };
  return model;
}
//保存
export const SaveModel = async (params: MesModelListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('MES_PROD_MODEL', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    params.CREATE_USER = useUserStore().getUserInfo.userId;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('MES_PROD_MODEL', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};
//删除
export const DeleteModel = async (params: Recordable) => {
  const usParams = genAction('MES_PROD_MODEL', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
